/* this is a script for making block type shapes

REV-1 DESIGN STARTED 01-09-2020
REV-1.1 circular pitch holes, span of holes added
REV-1.2 nut rotation, nut retaining slot added
        hole exist,type,dia,length part of array shuffled about
        29-10-2021 JMC
REV-1.3 add radial holes to circlar array JMC 01-11-21

AUTHOR JOHN MCPHEE

Generally this script is for generating blocks.
The block has various options and features enabled by an "exist" parameter.
The parameters are grouped by features, the parameters are hopefully self explanetry.
first two stages add and subtract cylinders and cubes sucsessively and final
operation is to remove holes

*/

///////////////////////////////////////////////////////////////
//future addition to consider
///////////////////////////////////////////////////////////////

// nema motor mount
// geared motor mount or use include???? own version
// more imports, say 5



///////////////////////////////////////////////////////////////
//to sort this version
///////////////////////////////////////////////////////////////

//rounded box top not working properly


///////////////////////////////////////////////////////////////
//include libraries
///////////////////////////////////////////////////////////////

//use <my_threads.scad>;

///////////////////////////////////////////////////////////////
//define resolution
///////////////////////////////////////////////////////////////

$fn=50;

///////////////////////////////////////////////////////////////
//PARAMETERS FOR POSITIONING PARTS FOR PRINTING
///////////////////////////////////////////////////////////////

block_print = 1;

////////////////////////////////////////////////////////////////
//PARAMETERS FOR STAGE 1 OF THE BLOCK BUILD
////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//add and subtract shapes to create your basic block
//4 arrays 2 for cylinders, 2 for cubes
/////////////////////////////////////////////////////////
//define cylinders
/*
[0]  = [ cylinder exists: 0=no 1= exists ] 
[1]  = [ diameter of cylinder: number ]
[2]  = [ length of cylinder: number ]

[3] = [ translation in x direction: number ]
[4] = [ translation in y direction: number ]
[5] = [ translation in z direction: number ]
[6] = [ rotation in x plane: number ]
[7] = [ rotation in y plane: number ]
[8] = [ rotation in z plane: number ]

*/
//define stage 1 positive cylinders
stage_1_pos_cylinders_exist = 1;
stage_1_pos_first_cylinder = 0;
stage_1_pos_last_cylinder = 0;

stage_1_pos_cylinder =
[ //start array of cylinders

//cylinder  position
[1,109.53,39,  0,0,0,0,0,0], //cylinder 0 main body
[0,0,0,     0,0,0,0,0,0], //cylinder 1
[0,0,0,     0,0,0,0,0,0], //cylinder 2
[0,0,0,     0,0,0,0,0,0], //cylinder 3
[0,0,0,     0,0,0,0,0,0], //cylinder 4
[0,0,0,     0,0,0,0,0,0], //cylinder 5
[0,0,0,     0,0,0,0,0,0], //cylinder 6
[0,0,0,     0,0,0,0,0,0], //cylinder 7
[0,0,0,     0,0,0,0,0,0], //cylinder 8
[0,0,0,     0,0,0,0,0,0], //cylinder 9
[0,0,0,     0,0,0,0,0,0], //cylinder 10

]; //end array , add more if required


//define stage 1 negitive cylinders
stage_1_neg_cylinders_exist = 1;
stage_1_neg_first_cylinder = 0;
stage_1_neg_last_cylinder = 0;

stage_1_neg_cylinder =
[ //start array

//cylinder  position
[1,77.53,41,   0,0,0,0,0,0], //cylinder 0 hollow out body
[0,0,0,     0,0,0,0,0,0], //cylinder 1
[0,0,0,     0,0,0,0,0,0], //cylinder 2
[0,0,0,     0,0,0,0,0,0], //cylinder 3
[0,0,0,     0,0,0,0,0,0], //cylinder 4
[0,0,0,     0,0,0,0,0,0], //cylinder 5
[0,0,0,     0,0,0,0,0,0], //cylinder 6
[0,0,0,     0,0,0,0,0,0], //cylinder 7
[0,0,0,     0,0,0,0,0,0], //cylinder 8
[0,0,0,     0,0,0,0,0,0], //cylinder 9
[0,0,0,     0,0,0,0,0,0], //cylinder 10

]; //end array , add more if required

//define blocks
/*
[0]  = [ block exists: 0=no 1= exists ] 
[1]  = [ dimention x: number ]
[2]  = [ dimention y: number ]
[3]  = [ dimention z: number ]

[4]  = [ hull corner radius: number ]
[5]  = [ top radius exists: 0=no 1= exists ] must have a number in [4] when ==1 

[6]  = [ translation in x direction: number ]
[7]  = [ translation in y direction: number ]
[8]  = [ translation in z direction: number ]
[9]  = [ rotation in x plane: number ]
[10] = [ rotation in y plane: number ]
[11] = [ rotation in z plane: number ]

*/
//define stage 1 positive blocks
stage_1_pos_blocks_exist = 0;
stage_1_pos_first_block = 0;
stage_1_pos_last_block = 0;

stage_1_pos_block =
[ //start array

//cube         hull   position
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 0
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 1
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 2
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 3
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 4
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 5
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 6
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 7
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 8
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 9
[0,0,0,0,      0,0,   0,0,0,0,0,0], //block 10

]; //end array , add more if required

//define stage 1 negitive blocks
stage_1_neg_blocks_exist = 1;
stage_1_neg_first_block = 0;
stage_1_neg_last_block = 1;

stage_1_neg_block =
[ //start array

//cube        hull   position
[1,110,10,40, 0,0,   0,54,0,0,0,0],  //block 0 slice end 1
[1,110,10,40, 0,0,   0,-54,0,0,0,0], //block 1 slice end 2
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 2
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 3
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 4
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 5
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 6
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 7
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 8
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 9
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 10

]; //end array , add more if required

//define stage 1 positive polygon
stage_1_pos_polygon_exists = 0;
stage_1_pos_polygon_depth =10;
//polygon shape
stage_1_pos_polygon = [ [0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0] ];
//polygon position
stage_1_pos_polygon_shift = [0,0,0,0,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//define stage 1 negitive polygon
stage_1_neg_polygon_exists = 1;
stage_1_neg_polygon_depth =40;
//polygon shape
stage_1_neg_polygon = [ [0,0],[-86.6,150],[-86.6,-150]
                      ];
//polygon position
stage_1_neg_polygon_shift = [0,0,0,0,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

////////////////////////////////////////////////////////
//PARAMETERS FOR STAGE 2 OF THE BUILD
////////////////////////////////////////////////////////

////////////////////////////////////////////////////////
//add and subtract shapes to progress your block
//4 arrays 2 for cylinders, 2 for cubes
////////////////////////////////////////////////////////

//define cylinders
/*

[0]  = [ cylinder exists: 0=no 1= exists ] 
[1]  = [ diameter of cylinder: number ]
[2]  = [ length of cylinder: number ]

[3] = [ translation in x direction: number ]
[4] = [ translation in y direction: number ]
[5] = [ translation in z direction: number ]
[6] = [ rotation in x plane: number ]
[7] = [ rotation in y plane: number ]
[8] = [ rotation in z plane: number ]

*/

//define stage 2 positive cylinders
stage_2_pos_cylinders_exist = 1;
stage_2_pos_first_cylinder = 0;
stage_2_pos_last_cylinder = 1;

stage_2_pos_cylinder =
[ //start array

//cylinder  position
[1,16,39,     -23.385,40.5,0,0,0,0], //cylinder 0 rounded end
[1,16,39,     -23.385,-40.5,0,0,0,0], //cylinder 1 rounded end
[0,0,0,     0,0,0,0,0,0], //cylinder 2
[0,0,0,     0,0,0,0,0,0], //cylinder 3
[0,0,0,     0,0,0,0,0,0], //cylinder 4
[0,0,0,     0,0,0,0,0,0], //cylinder 5
[0,0,0,     0,0,0,0,0,0], //cylinder 6
[0,0,0,     0,0,0,0,0,0], //cylinder 7
[0,0,0,     0,0,0,0,0,0], //cylinder 8
[0,0,0,     0,0,0,0,0,0], //cylinder 9
[0,0,0,     0,0,0,0,0,0], //cylinder 10

]; //end array , add more if required

//define stage 2 negitive cylinders
stage_2_neg_cylinders_exist = 0;
stage_2_neg_first_cylinder = 0;
stage_2_neg_last_cylinder = 0;

stage_2_neg_cylinder =
[ //start array

//cylinder  position
[0,0,0,     0,0,0,0,0,0], //cylinder 0
[0,0,0,     0,0,0,0,0,0], //cylinder 1
[0,0,0,     0,0,0,0,0,0], //cylinder 2
[0,0,0,     0,0,0,0,0,0], //cylinder 3
[0,0,0,     0,0,0,0,0,0], //cylinder 4
[0,0,0,     0,0,0,0,0,0], //cylinder 5
[0,0,0,     0,0,0,0,0,0], //cylinder 6
[0,0,0,     0,0,0,0,0,0], //cylinder 7
[0,0,0,     0,0,0,0,0,0], //cylinder 8
[0,0,0,     0,0,0,0,0,0], //cylinder 9
[0,0,0,     0,0,0,0,0,0], //cylinder 10

]; //end array , add more if required


//define blocks
/*
[0]  = [ block exists: 0=no 1= exists ] 
[1]  = [ dimention x: number ]
[2]  = [ dimention y: number ]
[3]  = [ dimention z: number ]

[4]  = [ hull corner radius: number ]
[5]  = [ top radius exists: 0=no 1= exists ] 

[6]  = [ translation in x direction: number ]
[7]  = [ translation in y direction: number ]
[8]  = [ translation in z direction: number ]
[9]  = [ rotation in x plane: number ]
[10] = [ rotation in y plane: number ]
[11] = [ rotation in z plane: number ]

*/

//define stage 2 positive blocks
stage_2_pos_blocks_exist = 0;
stage_2_pos_first_block = 0;
stage_2_pos_last_block = 0;

stage_2_pos_block =
[ //start array

//cube        hull   position
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 0
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 1
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 2
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 3
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 4
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 5
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 6
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 7
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 8
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 9
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 10

]; //end array , add more if required

//define stage 2 negitive blocks
stage_2_neg_blocks_exist = 0;
stage_2_neg_first_block = 0;
stage_2_neg_last_block = 0;

stage_2_neg_block =
[ //start array

//cube        hull   position
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 0
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 1
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 2
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 3
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 4
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 5
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 6
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 7
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 8
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 9
[0,0,0,0,     0,0,   0,0,0,0,0,0], //block 10

]; //end array , add more if required

//define stage 2 positive polygon
stage_2_pos_polygon_exists = 0;
stage_2_pos_polygon_depth =10;
//polygon shape
stage_2_pos_polygon = [ [0,0],[0,20],[10,20],[10,15],[20,15],[30,10],[20,5],[20,0] ];
//polygon position
stage_2_pos_polygon_shift = [0,5,80,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//define stage 1 negitive polygon
stage_2_neg_polygon_exists = 0;
stage_2_neg_polygon_depth =30;
//polygon shape
stage_2_neg_polygon = [ [0,0],[0,20],[10,20],[10,15],[20,15],[30,10],[20,5],[20,0] ];
//polygon position
stage_2_neg_polygon_shift = [0,-15,30,90,0,180] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot


//define array of pillers to block
block_pillers_exist = 0;
block_pillers_outer_only = 1;
block_pillers_dia = 10;
block_pillers_length = 40;
block_pillers_x_qty = 3;
block_pillers_y_qty = 2;
block_pillers_x_pitch = 60;
block_pillers_y_pitch = 100;
block_pillers_shift = [0,0,0,0,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

/////////////////////////////////////////////////////////////////////
//define circular spokes
////////////////////////////////////////////////////////////////////

//positive spoke
circ_spoke_pos_exist = 0;
// total number of slots
circ_spoke_pos_qty = 8;
// total angle for number of slots
circ_spoke_pos_angle = 360;
//initial angle offset
circ_spoke_pos_angle_offset =0;
// angle covered by each slot
circ_spoke_pos_slot_angle = 20;
// diameter of each slot
circ_spoke_pos_slot_dia =7;
// height of slot
circ_spoke_pos_slot_height = 20;
// slot centre distance from body centre
circ_spoke_pos_slot_pcd = 20;
// position the slots in a position
circ_spoke_pos_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//negitive spoke
circ_spoke_neg_exist = 0;
// total number of slots
circ_spoke_neg_qty = 2;
// total angle for number of slots
circ_spoke_neg_angle = 360;
//initial angle offset
circ_spoke_neg_angle_offset =45;
// angle covered by each slot
circ_spoke_neg_slot_angle = 90;
// diameter of each slot
circ_spoke_neg_slot_dia =7;
// height of slot
circ_spoke_neg_slot_height = 20;
// slot centre distance from body centre
circ_spoke_neg_slot_pcd = 20;
// position the slots in a position
circ_spoke_neg_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

////////////////////////////////////////////////////////////////
//PARAMETERS FOR STAGE 3 OF THE block AND LID BUILD
//
//if required add entry bosses, import .stl files, 
//positive text, mounting fixtures, terminal strips
//
//then if required remove negative text, coin slot
//holes:- clearance, counterbore, nut retainer, threaded
////////////////////////////////////////////////////////

//define a geared stepper motor mount
motor_mount_exists = 0;
motor_mount_height = 10;
motor_mount_piller_dia = 10;
//orient the motor mount
motor_mount_shift = [-20.5,-5,42.5,270,300,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

motor_mount_rot_x = 270;
motor_mount_rot_y = 300;
motor_mount_rot_z = 0;
//position the motor mount
motor_mount_pos_x = -20.5;
motor_mount_pos_y = -5;
motor_mount_pos_z = 42.5;

//import a .stl file to decorate the end of retainer
//place xxx.stl in same directory as this scsd file

//block import 1
block_import_1_stl_exists =0; //0 or 1
block_import_1_stl_file = "TreeOfLife_40mm_Fan_guard.stl";
//size the import
block_import_1_scale_x = 2;
block_import_1_scale_y = 2;            
block_import_1_scale_z = 2;            
//orient the imported stl file
block_import_1_rot_x = 0;
block_import_1_rot_y = 0;
block_import_1_rot_z = 0;
//position the imported stl file
block_import_1_pos_x = 0;
block_import_1_pos_y = 0;
block_import_1_pos_z = 60;

//print some text on block

block_text_1_exists = 0;
block_text_1_type = 0; // 0= raised 1= sunken
block_text_1_string = ["text xpos1",
                       "text xpos2",
                       "text xpos3",
                       "text xpos4",
                       "text xpos5",
                       "text xpos6"];
block_text_1_size = 10;
block_text_1_font = "DejaVu Sans      Mono:style=Bold";
block_text_1_direction = "ltr"; //"ltr"(left-to-right),"rtl"(right-to-left),
                                  //"ttb"(top-to-bottom), "btt"(bottom-to-top)
block_text_1_halign = "center";  // "left", "center", "right"
block_text_1_valign = "center";  // "left", "center", "right"
block_text_1_spacing = 1.0;
block_text_1_no_of_lines = 5; // 1-6 or no of strings in array
block_text_1_line_spacing = 10;
block_text_1_extrude_height = 2;
block_text_1_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//print some text on block

block_text_2_exists = 0;
block_text_2_type = 1; // 0= raised 1= sunken
block_text_2_string = ["text xneg1",
                       "text xneg2",
                       "text xneg3",
                       "text xneg4",
                       "text xneg5",
                       "text xneg6"];
block_text_2_size = 10;
block_text_2_font = "DejaVu Sans      Mono:style=Bold";
block_text_2_direction = "ltr"; //"ltr"(left-to-right),"rtl"(right-to-left),
                                  //"ttb"(top-to-bottom), "btt"(bottom-to-top)
block_text_2_halign = "center";  // "left", "center", "right"
block_text_2_valign = "center";  // "left", "center", "right"
block_text_2_spacing = 1.0;
block_text_2_no_of_lines = 5; // 1-6 or no of strings in array
block_text_2_line_spacing = 10;
block_text_2_extrude_height = 2;
block_text_2_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//print some text on block

block_text_3_exists = 0;
block_text_3_type = 1; // 0= raised 1= sunken
block_text_3_string = ["text ypos1",
                       "text ypos2",
                       "text ypos3",
                       "text ypos4",
                       "text ypos5",
                       "text ypos6"];
block_text_3_size = 10;
block_text_3_font = "DejaVu Sans      Mono:style=Bold";
block_text_3_direction = "ltr"; //"ltr"(left-to-right),"rtl"(right-to-left),
                                  //"ttb"(top-to-bottom), "btt"(bottom-to-top)
block_text_3_halign = "center";  // "left", "center", "right"
block_text_3_valign = "center";  // "left", "center", "right"
block_text_3_spacing = 1.0;
block_text_3_no_of_lines = 5; // 1-6 or no of strings in array
block_text_3_line_spacing = 10;
block_text_3_extrude_height = 2;
block_text_3_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//print some text on block

block_text_4_exists = 0;
block_text_4_type = 0; // 0= raised 1= sunken
block_text_4_string = ["text yneg1",
                       "text yneg2",
                       "text yneg3",
                       "text yneg4",
                       "text yneg5",
                       "text yneg6"];
block_text_4_size = 8;
block_text_4_font = "DejaVu Sans      Mono:style=Bold";
block_text_4_direction = "ltr"; //"ltr"(left-to-right),"rtl"(right-to-left),
                                  //"ttb"(top-to-bottom), "btt"(bottom-to-top)
block_text_4_halign = "center";  // "left", "center", "right"
block_text_4_valign = "center";  // "left", "center", "right"
block_text_4_spacing = 1.0;
block_text_4_no_of_lines = 5; // 1-6 or no of strings in array
block_text_4_line_spacing = 5;
block_text_4_extrude_height = 5;
block_text_4_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//print some text on block

block_text_5_exists = 0;
block_text_5_type = 0; // 0= raised 1= sunken
block_text_5_string = ["111  222  333",
                       "444  555  666",
                       "777  888  999",
                       " 10   11   12 ",
                       "text 5 5",
                       "text 5 6"];
block_text_5_size = 10;
block_text_5_font = "DejaVu Sans      Mono:style=Bold";
block_text_5_direction = "ltr"; //"ltr"(left-to-right),"rtl"(right-to-left),
                                  //"ttb"(top-to-bottom), "btt"(bottom-to-top)
block_text_5_halign = "center";  // "left", "center", "right"
block_text_5_valign = "center";  // "left", "center", "right"
block_text_5_spacing = 1.0;
block_text_5_no_of_lines = 5; // 1-6 or no of strings in array
block_text_5_line_spacing = 20;
block_text_5_extrude_height = 2;
block_text_5_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot



// cant find a way of indirectly calling modules by name
// so done using if statement
// these are all fixed size dedicated objects, no parameters
//
//1 calls "generate_motor_mount()"
//2 calls "3_axis_nano_board()"
//3 calls "small_limit_switch()"

//import an object from library
import_fixture_1_exists = 0;
fixture_1 = 1; //pick from list
fixture_1_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//import an object from library
import_fixture_2_exists = 0;
fixture_2 = 2; //pick from list
fixture_2_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//import an object from library
import_fixture_3_exists = 0;
fixture_3 = 3; //pick from list
fixture_3_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//import an object from library
import_fixture_4_exists = 0;
fixture_4 = 4; //pick from list
fixture_4_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//import an object from library
import_fixture_5_exists = 0;
fixture_5 = 5; //pick from list
fixture_5_shift = [0,50,30,90,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot

//add a bearing groove to the block

block_ball_groove_exists = 0;
block_ball_groove_size = 4;
block_ball_groove_dia = 60;
block_ball_groove_shift = [0,0,-0.5,0,0,0] ; //x_pos,y_pos,z_pos,x_rot,y_rot,z_rot


/////////////////////////////////////////////////////////
//put holes where you want them
/////////////////////////////////////////////////////////
//define holes
/*

[0]  = [ hole exists: 0=no 1= exists ]
[1]  = [ hole size relates to metric screw: 0=actual 1=thread clearance ]
[2]  = [ size of hole in mm: number ]
[3]  = [ length of hole:number ]

[4]  = [ rectangular array of holes exist: 0=no 1=exists ]
[5]  = [ x axis qty of holes: number ]
[6]  = [ x axis pitch of holes: number ]
[7]  = [ y axis qty of holes: number ]
[8]  = [ y axis pitch of holes: number ]
[9]  = [ rectangular array outside holes only: 0= all holes 1=outside only ]

[10] = [ axial circular array of holes exist: 0=no 1=exists ]
[11] = [ radial circular array of holes exist: 0=no 1=exists ]
[12] = [ qty of holes in circular array: number ]
[13] = [ P.C.D. of circular array of holes: number ]
[13] = [ span of holes: number ]

[15] = [ recess exists on hole: 0=no 1=exists ]
[16] = [ recess type: 0=countersink 1=counterbore ]
[17] = [ counterbore depth: number ]
[18] = [ counterbore height offset: number ]
 
[19] = [ nut retainer hole exists on hole: 0=no 1=exists ]
[20] = [ nut retainer depth: number ]
[21] = [ nut retainer height offset: number ]
[22] = [ nut rotation around axis : number ]

[23] = [ thread on hole exists: 0=no 1=exists ]
[24] = [ pitch of thread: number ]
[25] = [ depth of thread: number ]
[26] = [ angle of thread: number ]
[27] = [ thread height offset: number ]

[28] = [ nut retaining slot exists: 0=no 1=exists ]
[29] = [ nut retaining slot x dimention: number ]
[30] = [ nut retaining slot y dimention: number ]
[31] = [ nut retaining slot z dimention: number ]
[32] = [ nut retaining slot height offset: number ]

[33] = [ translation in x direction: number ]
[34] = [ translation in y direction: number ]
[35] = [ translation in z direction: number ]
[36] = [ rotation in x plane: number ]
[37] = [ rotation in y plane: number ]
[38] = [ rotation in z plane: number ]

*/
//define block holes,holes_from_array decodes holes
block_holes_exist = 1;
block_first_hole = 0;
block_last_hole = 0;

hole =
[ //start array

// hole       rect           circ         recess   nut         thread      slot        position

//hole 0 3 motor fixing holes 93.53 = 2 * (40.5/sin60)
[1,1,6,40,   0,0,0,0,0,0,  1,0,3,93.53,360,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 1
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 2
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 3
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 4
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 5
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 6
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 7
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 8
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 9
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 10
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 11
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 12
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 13
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 14
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 15
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 16
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 17
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 18
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 19
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 20
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],
//hole 21
[0,0,0,0,   0,0,0,0,0,0,  0,0,0,0,0,   0,0,0,0,  0,0,0,0,   0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0,0],

]; //end array , add more if required


/////////////////////////////////////////////////////////
//run the rendering
/////////////////////////////////////////////////////////

//draw the block
if (block_print==1)
{    
    translate([0,0,0])
    block_stage_3_build();
}  

//////////////////////////////////////////////////////////////
// build the basic block shape and hollow out
//////////////////////////////////////////////////////////////

module  block_stage_1_build()
{
    difference()
    {
        union()
        {
            //draw the block initial shape 
            //add cylinders
            if (stage_1_pos_cylinders_exist==1)
            {
                for(i=[stage_1_pos_first_cylinder:stage_1_pos_last_cylinder])
                {
                    cylinder_form ( stage_1_pos_cylinder [i][0], //exists
                                    stage_1_pos_cylinder [i][1], //dia
                                    stage_1_pos_cylinder [i][2], //length
                                    stage_1_pos_cylinder [i][3], //x move
                                    stage_1_pos_cylinder [i][4], //y move
                                    stage_1_pos_cylinder [i][5], //z move
                                    stage_1_pos_cylinder [i][6], //x rotate
                                    stage_1_pos_cylinder [i][7], //y rotate
                                    stage_1_pos_cylinder [i][8]  //z rotate
                                    );
                }
            }
            
            //add blocks
            if (stage_1_pos_blocks_exist==1)
            {
                for(i=[stage_1_pos_first_block:stage_1_pos_last_block])
                {
                    block_form ( stage_1_pos_block [i][0], //exists
                                 stage_1_pos_block [i][1], //x dimention
                                 stage_1_pos_block [i][2], //y dimention
                                 stage_1_pos_block [i][3], //y dimention
                                 stage_1_pos_block [i][4], //hull radius
                                 stage_1_pos_block [i][5], //top radius exists
                                 stage_1_pos_block [i][6], //x move
                                 stage_1_pos_block [i][7], //y move
                                 stage_1_pos_block [i][8], //z move
                                 stage_1_pos_block [i][9], //x rotate
                                 stage_1_pos_block [i][10], //y rotate
                                 stage_1_pos_block [i][11]  //z rotate
                                 );
                }            
           }
         
           if (stage_1_pos_polygon_exists==1)
           {
                translate ([stage_1_pos_polygon_shift[0],
                            stage_1_pos_polygon_shift[1],
                            stage_1_pos_polygon_shift[2]])
                rotate ([stage_1_pos_polygon_shift[3],
                         stage_1_pos_polygon_shift[4],
                         stage_1_pos_polygon_shift[5]])
                linear_extrude(stage_1_pos_polygon_depth)  
                polygon (stage_1_pos_polygon);  
           }

        }//end of union
            
            //remove bits from the block

            //remove parts initial shape 
            //remove cylinders
            if (stage_1_neg_cylinders_exist==1)
            {
                for(i=[stage_1_neg_first_cylinder:stage_1_neg_last_cylinder])
                {
                    cylinder_form ( stage_1_neg_cylinder [i][0], //exists
                                    stage_1_neg_cylinder [i][1], //dia
                                    stage_1_neg_cylinder [i][2], //length
                                    stage_1_neg_cylinder [i][3], //x move
                                    stage_1_neg_cylinder [i][4], //y move
                                    stage_1_neg_cylinder [i][5], //z move
                                    stage_1_neg_cylinder [i][6], //x rotate
                                    stage_1_neg_cylinder [i][7], //y rotate
                                    stage_1_neg_cylinder [i][8]  //z rotate
                                    );
                }
            }
            
            //remove blocks
            if (stage_1_neg_blocks_exist==1)
            {
                for(i=[stage_1_neg_first_block:stage_1_neg_last_block])
                {
                    block_form ( stage_1_neg_block [i][0], //exists
                                 stage_1_neg_block [i][1], //x dimention
                                 stage_1_neg_block [i][2], //y dimention
                                 stage_1_neg_block [i][3], //y dimention
                                 stage_1_neg_block [i][4], //hull radius
                                 stage_1_neg_block [i][5], //top radius exists
                                 stage_1_neg_block [i][6], //x move
                                 stage_1_neg_block [i][7], //y move
                                 stage_1_neg_block [i][8], //z move
                                 stage_1_neg_block [i][9], //x rotate
                                 stage_1_neg_block [i][10], //y rotate
                                 stage_1_neg_block [i][11]  //z rotate
                                 );
                }            
            }
            
            if (stage_1_neg_polygon_exists==1)
            {
                translate ([stage_1_neg_polygon_shift[0],
                            stage_1_neg_polygon_shift[1],
                            stage_1_neg_polygon_shift[2]])
                rotate ([stage_1_neg_polygon_shift[3],
                         stage_1_neg_polygon_shift[4],
                         stage_1_neg_polygon_shift[5]])
                linear_extrude(stage_1_neg_polygon_depth)  
                polygon (stage_1_neg_polygon);  
            }

            

        }//end difference  
}

////////////////////////////////////////////////////////
//block stage 2 build
////////////////////////////////////////////////////////

module block_stage_2_build()
{

    difference()
    {
        union()
        {
            //draw the initial stage 
            block_stage_1_build();
            
            //add shapes stage 2 
            //add cylinders
            if (stage_2_pos_cylinders_exist==1)
            {
                for(i=[stage_2_pos_first_cylinder:stage_2_pos_last_cylinder])
                {
                    cylinder_form ( stage_2_pos_cylinder [i][0], //exists
                                    stage_2_pos_cylinder [i][1], //dia
                                    stage_2_pos_cylinder [i][2], //length
                                    stage_2_pos_cylinder [i][3], //x move
                                    stage_2_pos_cylinder [i][4], //y move
                                    stage_2_pos_cylinder [i][5], //z move
                                    stage_2_pos_cylinder [i][6], //x rotate
                                    stage_2_pos_cylinder [i][7], //y rotate
                                    stage_2_pos_cylinder [i][8]  //z rotate
                                    );
                }
            }
            
            //add blocks
            if (stage_2_pos_blocks_exist==1)
            {
                for(i=[stage_2_pos_first_block:stage_2_pos_last_block])
                {
                    block_form ( stage_2_pos_block [i][0], //exists
                                 stage_2_pos_block [i][1], //x dimention
                                 stage_2_pos_block [i][2], //y dimention
                                 stage_2_pos_block [i][3], //y dimention
                                 stage_2_pos_block [i][4], //hull radius
                                 stage_2_pos_block [i][5], //top radius exists
                                 stage_2_pos_block [i][6], //x move
                                 stage_2_pos_block [i][7], //y move
                                 stage_2_pos_block [i][8], //z move
                                 stage_2_pos_block [i][9], //x rotate
                                 stage_2_pos_block [i][10], //y rotate
                                 stage_2_pos_block [i][11]  //z rotate
                                 );
                }            
            }
            
            //add polygon
            if (stage_2_pos_polygon_exists==1)
           {
                translate ([stage_2_pos_polygon_shift[0],
                            stage_2_pos_polygon_shift[1],
                            stage_2_pos_polygon_shift[2]])
                rotate ([stage_2_pos_polygon_shift[3],
                         stage_2_pos_polygon_shift[4],
                         stage_2_pos_polygon_shift[5]])
                linear_extrude(stage_2_pos_polygon_depth)  
                polygon (stage_2_pos_polygon);  
           }
                
               
                //add an array of pillers to the block
                if (block_pillers_exist == 1)
                {
                translate([block_pillers_shift[0],
                           block_pillers_shift[1],
                           block_pillers_shift[2]])
                rotate([block_pillers_shift[3],
                        block_pillers_shift[4],
                        block_pillers_shift[5]])
                cylinder_array(block_pillers_dia,
                               block_pillers_length,
                               block_pillers_x_qty,
                               block_pillers_y_qty,
                               block_pillers_x_pitch,
                               block_pillers_y_pitch,
                               block_pillers_outer_only);
                }

            if (circ_spoke_pos_exist ==1)
            {
                translate ([ circ_spoke_pos_shift[0],
                             circ_spoke_pos_shift[1],
                             circ_spoke_pos_shift[2] ])
                rotate ([circ_spoke_pos_shift[3],
                         circ_spoke_pos_shift[4],
                         circ_spoke_pos_shift[5]])
                circular_spoke  (   circ_spoke_pos_qty,
                                    circ_spoke_pos_angle,
                                    circ_spoke_pos_angle_offset,
                                    circ_spoke_pos_slot_angle,
                                    circ_spoke_pos_slot_dia,
                                    circ_spoke_pos_slot_height,
                                    circ_spoke_pos_slot_pcd);
            }

            }//end of union
            
            //remove shapes stage 2 
            //remove cylinders
            
            if (stage_2_neg_cylinders_exist==1)
            {
                for(i=[stage_2_neg_first_cylinder:stage_2_neg_last_cylinder])
                {
                    cylinder_form ( stage_2_neg_cylinder [i][0], //exists
                                    stage_2_neg_cylinder [i][1], //dia
                                    stage_2_neg_cylinder [i][2], //length
                                    stage_2_neg_cylinder [i][3], //x move
                                    stage_2_neg_cylinder [i][4], //y move
                                    stage_2_neg_cylinder [i][5], //z move
                                    stage_2_neg_cylinder [i][6], //x rotate
                                    stage_2_neg_cylinder [i][7], //y rotate
                                    stage_2_neg_cylinder [i][8]  //z rotate
                                    );
                }            
                
            }
            
            //remove blocks
            if (stage_2_neg_blocks_exist==1)
            {
                for(i=[stage_2_neg_first_block:stage_2_neg_last_block])
                {
                    block_form ( stage_2_neg_block [i][0], //exists
                                 stage_2_neg_block [i][1], //x dimention
                                 stage_2_neg_block [i][2], //y dimention
                                 stage_2_neg_block [i][3], //y dimention
                                 stage_2_neg_block [i][4], //hull radius
                                 stage_2_neg_block [i][5], //top radius exists
                                 stage_2_neg_block [i][6], //x move
                                 stage_2_neg_block [i][7], //y move
                                 stage_2_neg_block [i][8], //z move
                                 stage_2_neg_block [i][9], //x rotate
                                 stage_2_neg_block [i][10], //y rotate
                                 stage_2_neg_block [i][11]  //z rotate
                                 );
                }            
            }
            
            //remove polygon
            if (stage_2_neg_polygon_exists==1)
            {
                translate ([stage_2_neg_polygon_shift[0],
                            stage_2_neg_polygon_shift[1],
                            stage_2_neg_polygon_shift[2]])
                rotate ([stage_2_neg_polygon_shift[3],
                         stage_2_neg_polygon_shift[4],
                         stage_2_neg_polygon_shift[5]])
                linear_extrude(stage_2_neg_polygon_depth)  
                polygon (stage_2_neg_polygon);  
            }

            if (circ_spoke_neg_exist ==1)
            {
                translate ([ circ_spoke_neg_shift[0],
                             circ_spoke_neg_shift[1],
                             circ_spoke_neg_shift[2] ])
                rotate ([circ_spoke_neg_shift[3],
                         circ_spoke_neg_shift[4],
                         circ_spoke_neg_shift[5]])
                circular_spoke  (   circ_spoke_neg_qty,
                                    circ_spoke_neg_angle,
                                    circ_spoke_neg_angle_offset,
                                    circ_spoke_neg_slot_angle,
                                    circ_spoke_neg_slot_dia,
                                    circ_spoke_neg_slot_height,
                                    circ_spoke_neg_slot_pcd);
            }
            
            //remove groove to take ball bearings
            if (block_ball_groove_exists == 1)
            {
                translate([block_ball_groove_shift[0],
                           block_ball_groove_shift[1],
                           block_ball_groove_shift[2]])
                rotate([block_ball_groove_shift[3],
                        block_ball_groove_shift[4],
                        block_ball_groove_shift[5]])
                {
                rotate_extrude()
                translate ([block_ball_groove_dia/2,0,0])
                circle (d=block_ball_groove_size);
                }
            }


        }//end difference
}//end module
    

////////////////////////////////////////////////////////
//block stage 3 build
//if required add entry boss 1-2, import stl file, 
//proud text 1-6 lines, import fixture 1-5, terminal strips
//
//then if required remove sunken text 1-6 lines,
//holes:-clearance, counterbored, nut holder, threaded 
////////////////////////////////////////////////////////

module block_stage_3_build()
{
        translate([0,0,0])
        rotate ([0,0,0])   
        difference()
            {
            union()
                {
                //import stage 2 build of the block
                block_stage_2_build();
                    
                //add stage 3 bits to go onto the block
                    
                 //geared motor mount
                if (motor_mount_exists==1)
                {
                    translate ([motor_mount_shift[0],motor_mount_shift[1],motor_mount_shift[2]])
                    rotate ([motor_mount_shift[3],motor_mount_shift[4],motor_mount_shift[5]])
                    generate_motor_mount();  
                }  
                 
                // import .stl file to block 1
                if (block_import_1_stl_exists==1)
                {
                    translate([block_import_1_pos_x,block_import_1_pos_y,block_import_1_pos_z])
                    rotate([block_import_1_rot_x,block_import_1_rot_y,block_import_1_rot_z])
                    scale([block_import_1_scale_x,block_import_1_scale_y,block_import_1_scale_z])
                    import(block_import_1_stl_file);
                }
                
                //add an object from library
                if (import_fixture_1_exists==1)
                {
                    translate([fixture_1_shift[0],fixture_1_shift[1],fixture_1_shift[2]])
                    rotate ([fixture_1_shift[3],fixture_1_shift[4],fixture_1_shift[5]])
                    {
                        if (fixture_1==1) { generate_motor_mount(); }
                        else if (fixture_1==2) { axis_nano_board(); }
                        else if (fixture_1==3) { small_limit_sw(); }
                        
                    }
                }
                
                //add an object from library
                if (import_fixture_2_exists==1)
                {
                    translate([fixture_2_shift[0],fixture_2_shift[1],fixture_2_shift[2]])
                    rotate ([fixture_2_shift[3],fixture_2_shift[4],fixture_2_shift[5]])
                    {
                        if (fixture_2==1) { generate_motor_mount(); }
                        else if (fixture_2==2) { axis_nano_board(); }
                        else if (fixture_2==3) { small_limit_sw(); }

                    }
                }
                
                //add an object from library
                if (import_fixture_3_exists==1)
                {
                    translate([fixture_3_shift[0],fixture_3_shift[1],fixture_3_shift[2]])
                    rotate ([fixture_3_shift[3],fixture_3_shift[4],fixture_3_shift[5]])
                    {
                        if (fixture_3==1) { generate_motor_mount(); }
                        else if (fixture_3==2) { axis_nano_board(); }
                        else if (fixture_3==3) { small_limit_sw(); }

                    }
                }
                
                //add an object from library
                if (import_fixture_4_exists==1)
                {
                    translate([fixture_4_shift[0],fixture_4_shift[1],fixture_4_shift[2]])
                    rotate ([fixture_4_shift[3],fixture_4_shift[4],fixture_4_shift[5]])
                    {
                        if (fixture_4==1) { generate_motor_mount(); }
                        else if (fixture_4==2) { axis_nano_board(); }
                        else if (fixture_4==3) { small_limit_sw(); }
                        
                    }
                }
                
                //add an object from library
                if (import_fixture_5_exists==1)
                {
                    translate([fixture_5_shift[0],fixture_5_shift[1],fixture_5_shift[2]])
                    rotate ([fixture_5_shift[3],fixture_5_shift[4],fixture_5_shift[5]])
                    {
                        if (fixture_5==1) { generate_motor_mount(); }
                        else if (fixture_5==2) { axis_nano_board(); }
                        else if (fixture_5==3) { small_limit_sw(); }
                        
                    }
                }
                                
                
                
                //add some positive text
                if ((block_text_1_exists==1)&&(block_text_1_type==0))
                {
                    block_text_1_face();
                }
                
                //add some positive text
                if ((block_text_2_exists==1)&&(block_text_2_type==0))
                {
                    block_text_2_face();
                }
                
                //add some positive text
                if ((block_text_3_exists==1)&&(block_text_3_type==0))
                {
                    block_text_3_face();
                }
                
                //add some positive text
                if ((block_text_4_exists==1)&&(block_text_4_type==0))
                {
                    block_text_4_face();
                }
                
                //add some positive text
                if ((block_text_5_exists==1)&&(block_text_5_type==0))
                {
                    block_text_5_face();
                }
                
 
                
                
                }//end union
 
                
                //subtract stage 3 bits of the block
                
                //add some negitive text
                if ((block_text_1_exists==1)&&(block_text_1_type==1))
                {
                    block_text_1_face();
                }
                
                //add some negitive text
                if ((block_text_2_exists==1)&&(block_text_2_type==1))
                {
                    block_text_2_face();
                }
                
                //add some negitive text
                if ((block_text_3_exists==1)&&(block_text_3_type==1))
                {
                    block_text_3_face();
                }
                
                //add some negitive text
                if ((block_text_4_exists==1)&&(block_text_4_type==1))
                {
                    block_text_4_face();
                }
                
                //add some negitive text
                if ((block_text_5_exists==1)&&(block_text_5_type==1))
                {
                    block_text_5_face();
                }
                
                        
            //remove holes
            if (block_holes_exist == 1)
            {    
                holes_from_array ( block_first_hole,
                                   block_last_hole);
            }
        }
}

////////////////////////////////////////////////////////
// forms and positions cylinders 
////////////////////////////////////////////////////////

 module cylinder_form ( cylinder_exist,  //exists
                        cylinder_dia,    //dia
                        cylinder_length, //length
                        cylinder_x_move, //x move
                        cylinder_y_move, //y move
                        cylinder_z_move, //z move
                        cylinder_x_rot,  //x rotate
                        cylinder_y_rot,  //y rotate
                        cylinder_z_rot  //z rotate
                        )
{
    if (cylinder_exist==1)
    {
        translate ([cylinder_x_move,cylinder_y_move,cylinder_z_move])
        rotate ([cylinder_x_rot,cylinder_y_rot,cylinder_z_rot])
        cylinder (d=cylinder_dia,h=cylinder_length);
    }
}

////////////////////////////////////////////////////////
// forms and positions blocks 
////////////////////////////////////////////////////////
module block_form ( block_exist,         //exists
                    block_x_size,        //x dimention
                    block_y_size,        //y dimention
                    block_z_size,        //y dimention
                    block_hull_rad,      //hull radius
                    block_top_rad_exist, //top radius exists
                    block_x_move,        //x move
                    block_y_move,        //y move
                    block_z_move,        //z move
                    block_x_rot,         //x rotate
                    block_y_rot,         //y rotate
                    block_z_rot          //z rotate
                    )
{
    if (block_exist==1)
    {
        translate ([block_x_move,block_y_move,block_z_move])
        rotate ([block_x_rot,block_y_rot,block_z_rot])
        rounded_block ( block_x_size,        //x dimention
                        block_y_size,        //y dimention
                        block_z_size,        //y dimention
                        block_hull_rad,      //hull radius
                        block_top_rad_exist);//top radius exists
       
//        cube ([block_x_size,block_y_size,block_z_size],center=true);
    }
}





////////////////////////////////////////////////////////
// make an array of cylinders for addition or subtraction
////////////////////////////////////////////////////////

module cylinder_array(cyl_dia,
                      cyl_length,
                      x_qty,
                      y_qty,
                      x_pitch,
                      y_pitch,
                      outer_only)
{
       
    translate ([0,y_pitch/2,0])
    for(y=[0:y_qty-1])
    {
        translate ([0,y_pitch*y-((y_pitch*(y_qty))/2),0])
        rotate ([0,0,0])
        for(x=[0:x_qty-1])
        {
            if (  (outer_only==1)  &&
                     (  
                     ((x==(0))||(x==(x_qty-1)))  ||  ((y==(0))||(y==(y_qty-1)))  
                     ) 
               )
            {
                translate ([x_pitch*x-((x_pitch*(x_qty-1))/2),0,0])
                rotate ([0,0,0])
                cylinder ( d = cyl_dia, h = cyl_length);

            }
            
            else if (outer_only==0)
            {
                translate ([x_pitch*x-((x_pitch*(x_qty-1))/2),0,0])
                rotate ([0,0,0])
                cylinder ( d = cyl_dia, h = cyl_length);
                    
            }
        }   
    }        
}

////////////////////////////////////////////////////////
// box shape with rounded corners 
////////////////////////////////////////////////////////

module rounded_block (length,
                      width,
                      height,
                      radius,
                      radius_exists)
{
    if ((radius_exists ==0)) // rounded box no radius top
    {
            radius = (radius + 0.01); //make it tiny so it generates block when zero
            
            hull()
            {
                translate( [length/2-radius,width/2-radius,0] )
                cylinder( r = radius, h = height);
                
                translate( [-length/2+radius,width/2-radius,0] )
                cylinder( r = radius, h = height);
                
                translate( [length/2-radius,-width/2+radius,0] )
                cylinder( r = radius, h = height);
                
                translate( [-length/2+radius,-width/2+radius,0] )
                cylinder( r = radius, h = height);	
            }
    }
    //put a radius on a block
    else
    {
            hull()
            {
                translate( [length/2-radius,width/2-radius,0] )
                {
                cylinder( r = radius, h = height-radius);
                translate( [0,0,height-radius] )
                sphere (r=radius);
                }
                
                translate( [-length/2+radius,width/2-radius,0] )
                {
                cylinder( r = radius, h = height-radius);
                translate( [0,0,height-radius] )
                sphere (r=radius);
                }
                
                translate( [length/2-radius,-width/2+radius,0] )
                {
                cylinder( r = radius, h = height-radius);
                translate( [0,0,height-radius] )
                sphere (r=radius);
                }
                
                translate( [-length/2+radius,-width/2+radius,0] )
                {
                cylinder( r = radius, h = height-radius);
                translate( [0,0,height-radius] )
                sphere (r=radius);
                }
            }
    }
}



////////////////////////////////////////////////////////
// makes a cutout where you tell it 
////////////////////////////////////////////////////////

module make_cutout (side_height,
                    cutout_side,//1=xpos.2=xneg.3=ypos.4=yneg.5=bottom
                    cutout_x_qty,
                    cutout_x_pitch,
                    cutout_y_qty,
                    cutout_y_pitch,
                    cutout_width,
                    cutout_height,
                    cutout_depth)
{
    if (cutout_side==1) //x positive face
    {
         translate ([(box_length/2)-(box_x_pos_recess_radius*box_x_pos_recess_exists)+0.1,
                    0,side_height/2])
        rotate ([0,270,0])
        for(i=[0:cutout_y_qty-1])
        {
            translate ([cutout_y_pitch*i-((cutout_y_pitch*(cutout_y_qty-1))/2),0,0,])
            translate ([0,(-(cutout_x_pitch*(cutout_x_qty-1))/2),0])
            for(i=[0:cutout_x_qty-1])
            {
                translate ([0,cutout_x_pitch*i,cutout_depth/2])
                cube([cutout_height,cutout_width,cutout_depth],center=true);

            }
        }    
    }
    
else if (cutout_side==2) //x negitive face       
    {
        translate ([-(box_length/2)+(box_x_neg_recess_radius*box_x_neg_recess_exists)-0.1,
                    0,side_height/2])
        rotate ([0,90,0])
        for(i=[0:cutout_y_qty-1])
        {
            translate ([cutout_y_pitch*i-((cutout_y_pitch*(cutout_y_qty-1))/2),0,0,])
            translate ([0,(-(cutout_x_pitch*(cutout_x_qty-1))/2),0])
            for(i=[0:cutout_x_qty-1])
            {
                translate ([0,cutout_x_pitch*i,cutout_depth/2])
                cube([cutout_height,cutout_width,cutout_depth],center=true);
            }
        }    
    }
    
    else if (cutout_side==3) //y positive face       
    {
        translate ([0,(box_width/2)-(box_y_pos_recess_radius*box_y_pos_recess_exists)+0.1,
                        side_height/2])
        rotate ([90,0,0])
        for(i=[0:cutout_y_qty-1])
        {
            translate ([0,cutout_y_pitch*i-((cutout_y_pitch*(cutout_y_qty-1))/2),0])
            translate ([(-(cutout_x_pitch*(cutout_x_qty-1))/2),0,0])
            for(i=[0:cutout_x_qty-1])
            {
                translate ([cutout_x_pitch*i,0,cutout_depth/2])
                rotate ([0,0,90])
                cube([cutout_height,cutout_width,cutout_depth],center=true);
            }
        }    
    }
    
    else if (cutout_side==4) //y negitive face       
    {
        translate ([0,-(box_width/2)+(box_y_neg_recess_radius*box_y_neg_recess_exists)-0.1,
                        side_height/2])
        rotate ([270,0,0])
        for(i=[0:cutout_y_qty-1])
        {
            translate ([0,cutout_y_pitch*i-((cutout_y_pitch*(cutout_y_qty-1))/2),0])
            translate ([(-(cutout_x_pitch*(cutout_x_qty-1))/2),0,0])
            for(i=[0:cutout_x_qty-1])
            {
                translate ([cutout_x_pitch*i,0,cutout_depth/2])
                rotate ([0,0,90])
                cube([cutout_height,cutout_width,cutout_depth],center=true);
            }
        }    
    }
    
    else if (cutout_side==5) //bottom face       
    {
        for(i=[0:cutout_y_qty-1])
        {
            translate ([0,cutout_y_pitch*i-((cutout_y_pitch*(cutout_y_qty-1))/2),0])
            translate ([(-(cutout_x_pitch*(cutout_x_qty-1))/2),0,0])
            for(i=[0:cutout_x_qty-1])
            {
                translate ([cutout_x_pitch*i,0,cutout_depth/2])
                rotate ([0,0,90])
                cube([cutout_height,cutout_width,cutout_depth],center=true);
            }
        }   
    }     
}


////////////////////////////////////////////////////////////////////////////
// x positive face text
////////////////////////////////////////////////////////////////////////////

module block_text_1_face()
{

    produce_text( block_text_1_string,
                  block_text_1_size,
                  block_text_1_font,
                  block_text_1_direction,
                  block_text_1_halign,
                  block_text_1_valign,
                  block_text_1_spacing,
                  block_text_1_no_of_lines,
                  block_text_1_line_spacing,
                  block_text_1_extrude_height,
                  block_text_1_shift[0],
                  block_text_1_shift[1],
                  block_text_1_shift[2],
                  block_text_1_shift[3],
                  block_text_1_shift[4],
                  block_text_1_shift[5]);
}

////////////////////////////////////////////////////////////////////////////
// x negitive face text
////////////////////////////////////////////////////////////////////////////

module block_text_2_face()
{

    produce_text( block_text_2_string,
                  block_text_2_size,
                  block_text_2_font,
                  block_text_2_direction,
                  block_text_2_halign,
                  block_text_2_valign,
                  block_text_2_spacing,
                  block_text_2_no_of_lines,
                  block_text_2_line_spacing,
                  block_text_2_extrude_height,
                  block_text_2_shift[0],
                  block_text_2_shift[1],
                  block_text_2_shift[2],
                  block_text_2_shift[3],
                  block_text_2_shift[4],
                  block_text_2_shift[5]);
}

////////////////////////////////////////////////////////////////////////////
// y positive face text
////////////////////////////////////////////////////////////////////////////

module block_text_3_face()
{

    produce_text( block_text_3_string,
                  block_text_3_size,
                  block_text_3_font,
                  block_text_3_direction,
                  block_text_3_halign,
                  block_text_3_valign,
                  block_text_3_spacing,
                  block_text_3_no_of_lines,
                  block_text_3_line_spacing,
                  block_text_3_extrude_height,
                  block_text_3_shift[0],
                  block_text_3_shift[1],
                  block_text_3_shift[2],
                  block_text_3_shift[3],
                  block_text_3_shift[4],
                  block_text_3_shift[5]);
}

////////////////////////////////////////////////////////////////////////////
// y negitive face text
////////////////////////////////////////////////////////////////////////////

module block_text_4_face()
{

    produce_text( block_text_4_string,
                  block_text_4_size,
                  block_text_4_font,
                  block_text_4_direction,
                  block_text_4_halign,
                  block_text_4_valign,
                  block_text_4_spacing,
                  block_text_4_no_of_lines,
                  block_text_4_line_spacing,
                  block_text_4_extrude_height,
                  block_text_4_shift[0],
                  block_text_4_shift[1],
                  block_text_4_shift[2],
                  block_text_4_shift[3],
                  block_text_4_shift[4],
                  block_text_4_shift[5]);
}

////////////////////////////////////////////////////////////////////////////
// block block top text
////////////////////////////////////////////////////////////////////////////

module block_text_5_face()
{

    produce_text( block_text_5_string,
                  block_text_5_size,
                  block_text_5_font,
                  block_text_5_direction,
                  block_text_5_halign,
                  block_text_5_valign,
                  block_text_5_spacing,
                  block_text_5_no_of_lines,
                  block_text_5_line_spacing,
                  block_text_5_extrude_height,
                  block_text_5_shift[0],
                  block_text_5_shift[1],
                  block_text_5_shift[2],
                  block_text_5_shift[3],
                  block_text_5_shift[4],
                  block_text_5_shift[5]);
}

////////////////////////////////////////////////////////////////////////////
//make some text
////////////////////////////////////////////////////////////////////////////

 module produce_text( string,
                      size_var,
                      font_var,
                      direction_var,
                      halign_var,
                      valign_var,
                      spacing_var,
                      line_num,
                      line_space,
                      extrude_height,
                      text_pos_x,
                      text_pos_y,
                      text_pos_z,
                      text_rot_x,
                      text_rot_y,
                      text_rot_z)
{
    translate ([text_pos_x,text_pos_y,text_pos_z])
    rotate ([text_rot_x,text_rot_y,text_rot_z])
    for (i=[0:line_num-1])
    {
        translate ([0,-line_space*i,0])
        linear_extrude(extrude_height)
        text (string[i],size=size_var,direction=direction_var,font=font_var,
              halign=halign_var,valign=valign_var);
    }
}



//////////////////////////////////////////////////////////////////
// makes holes in rectangular, circular or single positions
//////////////////////////////////////////////////////////////////
module holes_from_array ( first_hole,
                          last_hole)
{
            for (i=[first_hole:last_hole])
            {//start index
                if (hole[i][4] == 1) //rectangular array exists
                {
                    translate ([ hole[i][33],hole[i][34],hole[i][35] ])
                    rotate    ([ hole[i][36],hole[i][37],hole[i][38] ])
                    make_rect_array_holes ( hole[i][4],    //rect array exist
                                            hole[i][5],    //rect array x qty
                                            hole[i][6],    //rect array x pitch
                                            hole[i][7],    //rect array y qty
                                            hole[i][8],    //rect array y pitch
                                            hole[i][9],    //rect array outside only   
                                            hole[i][0],    //hole exists
                                            hole[i][1],    //actual or screw size
                                            hole[i][2],    //hole length
                                            hole[i][3],    //hole / thread diameter
                                            hole[i][15],   //recess exists
                                            hole[i][16],   //recess type
                                            hole[i][17],   //counterbore depth
                                            hole[i][18],   //counterbore height offset
                                            hole[i][19],   //nut retainer exists
                                            hole[i][20],   //nut hole depth
                                            hole[i][21],   //nut hole height offset
                                            hole[i][22],   //nut hole rotation
                                            hole[i][23],   //thread exists
                                            hole[i][24],   //thread pitch
                                            hole[i][25],   //thread depth
                                            hole[i][26],   //thread angle
                                            hole[i][27],   //thread height offset
                                            hole[i][28],   //nut slot exists
                                            hole[i][29],   //slot dim x
                                            hole[i][30],   //slot dim y
                                            hole[i][31],   //slot dim z
                                            hole[i][32]); //slot height offset
                    
                }
                
                else if ((hole [i][10] == 1)|| (hole [i][11] == 1))// circular aray exists
                {
                    translate ([ hole[i][33],hole[i][34],hole[i][35] ])
                    rotate    ([ hole[i][36],hole[i][37],hole[i][38] ])
                    make_circ_array_holes(  hole[i][10],   //axial circ array exist
                                            hole[i][11],   //radial circ array exist
                                            hole[i][12],   //circ qty of holes
                                            hole[i][13],   //circ PCD of holes
                                            hole[i][14],   //span of holes
                                            hole[i][0],    //hole exists
                                            hole[i][1],    //actual or screw size
                                            hole[i][2],    //hole length
                                            hole[i][3],    //hole / thread diameter
                                            hole[i][15],   //recess exists
                                            hole[i][16],   //recess type
                                            hole[i][17],   //counterbore depth
                                            hole[i][18],   //counterbore height offset
                                            hole[i][19],   //nut retainer exists
                                            hole[i][20],   //nut hole depth
                                            hole[i][21],   //nut hole height offset
                                            hole[i][22],   //nut hole rotation
                                            hole[i][23],   //thread exists
                                            hole[i][24],   //thread pitch
                                            hole[i][25],   //thread depth
                                            hole[i][26],   //thread angle
                                            hole[i][27],   //thread height offset
                                            hole[i][28],   //nut slot exists
                                            hole[i][29],   //slot dim x
                                            hole[i][30],   //slot dim y
                                            hole[i][31],   //slot dim z
                                            hole[i][32]); //slot height offset
                    }
                
                else // hole is a single entity
                {
                    translate ([ hole[i][33],hole[i][34],hole[i][35] ])
                    rotate    ([ hole[i][36],hole[i][37],hole[i][38] ])
                    make_single_hole( hole[i][0],    //hole exists
                                      hole[i][1],    //actual or screw size
                                      hole[i][2],    //hole length
                                      hole[i][3],    //hole / thread diameter
                                      hole[i][15],   //recess exists
                                      hole[i][16],   //recess type
                                      hole[i][17],   //counterbore depth
                                      hole[i][18],   //counterbore height offset
                                      hole[i][19],   //nut retainer exists
                                      hole[i][20],   //nut hole depth
                                      hole[i][21],   //nut hole height offset
                                      hole[i][22],   //nut hole rotation
                                      hole[i][23],   //thread exists
                                      hole[i][24],   //thread pitch
                                      hole[i][25],   //thread depth
                                      hole[i][26],   //thread angle
                                      hole[i][27],   //thread height offset
                                      hole[i][28],   //nut slots exists
                                      hole[i][29],   //slot dim x
                                      hole[i][30],   //slot dim y
                                      hole[i][31],   //slot dim z
                                      hole[i][32]);  //slot height offset
                                      
                }
                   
                
            }//end index
}

   //////////////////////////////////////////////////////////////////
   // make a rectangular array of holes
   //////////////////////////////////////////////////////////////////
   
    module make_rect_array_holes(rect_exist,    //rect array exist
                                 x_qty,         //rect array x qty
                                 x_pitch,       //rect array x pitch
                                 y_qty,         //rect array y qty
                                 y_pitch,       //rect array y pitch
                                 outer_only,    //rect array outside only
                                 hole_exist,    //hole exists
                                 hole_type,     //actual or screw size
                                 dia,           //thread diameter
                                 height,        //hole depth
                                 recess_exist,  //recess exists
                                 recess_type,   //recess type
                                 cbore_depth,   //counterbore depth
                                 cbore_offset,  //counterbore height offset
                                 nut_exist,     //nut retainer exists
                                 nut_depth,     //nut hole depth
                                 nut_offset,    //nut hole height offset
                                 nut_rotation,  //nut hole rotation
                                 thread_exist,  //thread exists
                                 thread_pitch,  //thread pitch
                                 thread_depth,  //thread depth
                                 thread_angle,  //thread angle
                                 thread_offset, //thread height offset
                                 slot_exist,   //nut slot exists
                                 slot_x_dim,    //slot x size
                                 slot_y_dim,    //slot y size
                                 slot_z_dim,    //slot z size
                                 slot_offset)   //slot offset                                
                                 
                                 
   {
       
    translate ([0,y_pitch/2,0])
    for(y=[0:y_qty-1])
    {
        translate ([0,y_pitch*y-((y_pitch*(y_qty))/2),0])
        rotate ([0,0,0])
        for(x=[0:x_qty-1])
        {
            if (  (outer_only==1)  &&
                     (  
                     ((x==(0))||(x==(x_qty-1)))  ||  ((y==(0))||(y==(y_qty-1)))  
                     ) 
               )
            {
                translate ([x_pitch*x-((x_pitch*(x_qty-1))/2),0,0])
                rotate ([0,0,0])
                make_single_hole(hole_exist,    //hole exists
                                 hole_type,     //actual or screw size
                                 dia,           //thread diameter
                                 height,        //hole depth
                                 recess_exist,   //recess exists
                                 recess_type,    //recess type
                                 cbore_depth,    //counterbore depth
                                 cbore_offset,   //counterbore height offset
                                 nut_exist,      //nut retainer exists
                                 nut_depth,      //nut hole depth
                                 nut_offset,     //nut hole height offset
                                 nut_rotation,   //nut hole rotation
                                 thread_exist,   //thread exists
                                 thread_pitch,   //thread pitch
                                 thread_depth,   //thread depth
                                 thread_angle,   //thread angle
                                 thread_offset, //thread height offset
                                 slot_exist,   //nut slot exists
                                 slot_x_dim,    //slot x size
                                 slot_y_dim,    //slot y size
                                 slot_z_dim,    //slot z size
                                 slot_offset);   //slot offset                                

            }
            
            else if (outer_only==0)
            {
                translate ([x_pitch*x-((x_pitch*(x_qty-1))/2),0,0])
                rotate ([0,0,0])
                make_single_hole(hole_exist,    //hole exists
                                 hole_type,     //actual or screw size
                                 dia,           //thread diameter
                                 height,        //hole depth
                                 recess_exist,   //recess exists
                                 recess_type,    //recess type
                                 cbore_depth,    //counterbore depth
                                 cbore_offset,   //counterbore height offset
                                 nut_exist,      //nut retainer exists
                                 nut_depth,      //nut hole depth
                                 nut_offset,     //nut hole height offset
                                 nut_rotation,  //nut hole rotation
                                 thread_exist,   //thread exists
                                 thread_pitch,   //thread pitch
                                 thread_depth,   //thread depth
                                 thread_angle,   //thread angle
                                 thread_offset, //thread height offset
                                 slot_exist,   //nut slot exists
                                 slot_x_dim,    //slot x size
                                 slot_y_dim,    //slot y size
                                 slot_z_dim,    //slot z size
                                 slot_offset);   //slot offset                                
                    
            }
        }   
    }        
}

    
   
   
   //////////////////////////////////////////////////////////////////
   // make a circular array of holes
   //////////////////////////////////////////////////////////////////
   
    module make_circ_array_holes(holes_axial,   //axial array exist
                                 holes_radial,  //radial array exist
                                 circ_qty,      //circ array qty
                                 pcd,           //circ PCD
                                 span,          //span of circles
                                 hole_exist,    //hole exists
                                 hole_type,     //actual or screw size
                                 dia,           //thread diameter
                                 height,        //hole depth
                                 recess_exist,  //recess exists
                                 recess_type,   //recess type
                                 cbore_depth,   //counterbore depth
                                 cbore_offset,  //counterbore height offset
                                 nut_exist,     //nut retainer exists
                                 nut_depth,     //nut hole depth
                                 nut_offset,    //nut hole height offset
                                 nut_rotation,  //nut hole rotation
                                 thread_exist,  //thread exists
                                 thread_pitch,  //thread pitch
                                 thread_depth,  //thread depth
                                 thread_angle,  //thread angle
                                 thread_offset, //thread height offset
                                 slot_exist,   //nut slot exists
                                 slot_x_dim,    //slot x size
                                 slot_y_dim,    //slot y size
                                 slot_z_dim,    //slot z size
                                 slot_offset)   //slot offset                                
   {

       
    #if (span >=360) // since last hole is same as first hole
    {
        translate ([0,0,0])
        for(i=[0:circ_qty-1])
        {
            //echo (i*(span/circ_qty));
            rotate ([0,90*holes_radial,i*(span/circ_qty)])
            translate ([pcd/2*holes_axial,0,pcd/2*holes_radial])
            make_single_hole(hole_exist,    //hole exists
                             hole_type,     //actual or screw size
                             dia,           //thread diameter
                             height,        //hole depth
                             recess_exist,   //recess exists
                             recess_type,    //recess type
                             cbore_depth,    //counterbore depth
                             cbore_offset,   //counterbore height offset
                             nut_exist,      //nut retainer exists
                             nut_depth,      //nut hole depth
                             nut_offset,     //nut hole height offset
                             nut_rotation,  //nut hole rotation
                             thread_exist,   //thread exists
                             thread_pitch,   //thread pitch
                             thread_depth,   //thread depth
                             thread_angle,   //thread angle
                             thread_offset, //thread height offset
                             slot_exist,   //nut slot exists
                             slot_x_dim,    //slot x size
                             slot_y_dim,    //slot y size
                             slot_z_dim,    //slot z size
                             slot_offset);   //slot offset                                
  
        }
    }
    else    // since last hole not same as first hole
    {
        for(i=[0:circ_qty-1])
        {
            echo (i*(span/(circ_qty-1)));
            rotate ([ 0,90*holes_radial,i*(span/(circ_qty-1))])   
            translate ([pcd/2*holes_axial,0,pcd/2*holes_radial])
            make_single_hole(hole_exist,    //hole exists
                             hole_type,     //actual or screw size
                             dia,           //thread diameter
                             height,        //hole depth
                             recess_exist,   //recess exists
                             recess_type,    //recess type
                             cbore_depth,    //counterbore depth
                             cbore_offset,   //counterbore height offset
                             nut_exist,      //nut retainer exists
                             nut_depth,      //nut hole depth
                             nut_offset,     //nut hole height offset
                             nut_rotation,  //nut hole rotation
                             thread_exist,   //thread exists
                             thread_pitch,   //thread pitch
                             thread_depth,   //thread depth
                             thread_angle,   //thread angle
                             thread_offset, //thread height offset
                             slot_exist,   //nut slot exists
                             slot_x_dim,    //slot x size
                             slot_y_dim,    //slot y size
                             slot_z_dim,    //slot z size
                             slot_offset);   //slot offset                                
  
        }     
   } 
 }  
   
   //////////////////////////////////////////////////////////////////
   // make a single hole as defined
   //////////////////////////////////////////////////////////////////
   
    module make_single_hole( hole_exist,    //hole exists
                             hole_type,     //actual or screw size
                             dia,           //thread diameter
                             height,        //hole depth
                             recess_exist,  //recess exists
                             recess_type,   //recess type
                             cbore_depth,   //counterbore depth
                             cbore_offset,  //counterbore height offset
                             nut_exist,     //nut retainer exists
                             nut_depth,     //nut hole depth
                             nut_offset,    //nut hole height offset
                             nut_rotation,  //nut hole rotation
                             thread_exist,  //thread exists
                             thread_pitch,  //thread pitch
                             thread_depth,  //thread depth
                             thread_angle,  //thread angle
                             thread_offset, //thread height offset
                             slot_exist,   //nut slot exists
                             slot_x_dim,    //slot x size
                             slot_y_dim,    //slot y size
                             slot_z_dim,    //slot z size
                             slot_offset)   //slot offset                                
                             
   {
    if (hole_exist == 1)
    {
        if (hole_type == 1) //1=clearance
        {    
            cylinder( d = ThreadToClearanceHole(dia), h = height + 0.01);
        }
        else // 0=actual size
        {
            cylinder( d = dia, h = height + 0.01);
        }
    }
       
    if ( recess_exist==1)
    {
        if (recess_type == 1) //counter bore
        {
            translate ([0,0,height - cbore_depth + cbore_offset ])
            cylinder( d = ThreadToCapHeadDiameter(dia),h = cbore_depth + 0.01);
        }
        else //countersink
        {
            cylinder((dia/2)*tan(45),
                      d1=dia*2,
                      d2=dia);   
        }
    }
    
    if ( nut_exist==1)
    {
        translate ([0,0,nut_offset-0.1 ])
        rotate ([0,0,nut_rotation])
        cylinder( d = HexAcrossFlatsToPointsDia(dia),h = nut_depth + 0.01,$fn=6);        
        
    }
    
    if ( thread_exist==1)
    {
        translate ([0,0,thread_offset ])
        // ScrewHole(outer_diam, height, position=[0,0,0], rotation=[0,0,0], pitch=0, tooth_angle=30, tolerance=0.4, tooth_height=0)
        ScrewHole(dia, thread_depth, [0, 0, 0], [0,0,0], thread_pitch);   
    }
    
    if ( slot_exist==1)
    {
        translate ([0,0,slot_z_dim/2+slot_offset-0.1 ])
        rotate ([0,0,0])
        cube([slot_x_dim,slot_y_dim,slot_z_dim],center=true);        
        
    }
       
}

////////////////////////////////////////////////////////////////////////////
//GENERATE ROTARY SLOT
////////////////////////////////////////////////////////////////////////////

module circular_spoke(  number_of_slots,
                        total_slots_angle,
                        initial_slot_offset,
                        individual_slot_angle,
                        slot_diameter,
                        slot_height,
                        slot_distance_from_centre)
{
               for (i=[0:number_of_slots-1])
               {
                    //insert one hole to create slot start curve
                    rotate(total_slots_angle/number_of_slots*i +initial_slot_offset)
                    translate([slot_distance_from_centre,0,0])
                    cylinder(slot_height,d=slot_diameter);
                    //insert another hole to create slot end curve
                    rotate((total_slots_angle/number_of_slots*i)+individual_slot_angle+initial_slot_offset)
                    translate([slot_distance_from_centre,0,0])
                    cylinder(slot_height,d=slot_diameter);
                    //insert the slot between the two holes
                    //rotate to the next slot
                    rotate(total_slots_angle/number_of_slots*i+initial_slot_offset)
                    //extrude the ring
                    rotate_extrude(angle=individual_slot_angle)
                    //move the circle from the centre
                    translate([slot_distance_from_centre-slot_diameter/2,0,0])
                    //draw a 2D rectangular on centre axis
                    square([slot_diameter,slot_height]);
                }
}

////////////////////////////////////////////////////////////////////////////
//GENERATE MOUNTING FOR GEARED STEPPER MOTOR
////////////////////////////////////////////////////////////////////////////

module generate_motor_mount()
{
    translate ([0,8,0]) //move shaft centre onto z axis
    difference()
    {
        union()
        {
            hull()
            {
                //large body circle
                translate( [0,0,0] )
                cylinder( r = 14, h = motor_mount_height);
                //x pos piller
                translate( [17.5,0,0] )
                cylinder( d = motor_mount_piller_dia, h = motor_mount_height);
                //x neg piller
                translate( [-17.5,0,0] )
                cylinder( d = motor_mount_piller_dia, h = motor_mount_height);
            }    

        }//end of union
            
            //remove motor body
            translate([0,0,0])
            cylinder( r = 14.1, h = motor_mount_height+0.01);

            //remove mounting flange
            hull()
            {
                //x pos piller
                translate( [17.5,0,motor_mount_height-1] )
                cylinder( r = 3.5, h = 1);
                //x neg piller
                translate( [-17.5,0,motor_mount_height-1] )
                cylinder( r = 3.5, h = 1);
            }
            //clean up the sharp corners
            translate( [0,0,10] )
            cube ([20,30,20],center=true);
            
            //holes for self tappers
            //x pos piller
            translate( [17.5,0,10] )
            cylinder( r = 1, h = 10);
            
            //x neg piller
            translate( [-17.5,0,10] )
            cylinder( r = 1, h = 10);

        }//end difference  
}
    

////////////////////////////////////////////////////////////////////////////
//function to return across flats dimention for metric bolts
// Provides standard metric hex head widths across the flats from thread size.

function ThreadToHexHeadAcrossFlats(size) =
  (size <= 64) ?
    lookup(size, [
      [2, 4],
      [2.5, 5],
      [3, 5.5],
      [3.5, 6],
      [4, 7],
      [5, 8],
      [6, 10],
      [7, 11],
      [8, 13],
      [10, 16],
      [12, 18],
      [14, 21],
      [16, 24],
      [18, 27],
      [20, 30],
      [22, 34],
      [24, 36],
      [27, 41],
      [30, 46],
      [33, 50],
      [36, 55],
      [39, 60],
      [42, 65],
      [48, 75],
      [52, 80],
      [56, 85],
      [60, 90],
      [64, 95]
        ]) : return;
 

////////////////////////////////////////////////////////////////////////////
//function to return across points dimention for metric bolts
// Provides standard metric hex head widths across points from across flats size.


function HexAcrossFlatsToPointsDia(diameter) =
  ThreadToHexHeadAcrossFlats(diameter) / cos(30);

 
////////////////////////////////////////////////////////////////////////////
//function to return across flats dimention for metric Allen head sockets
// Provides standard metric hex Allen head widths across the flats from thread size.
 
function ThreadToAllenHeadAcrossFlats(size) =
  (size <= 64) ?
    lookup(size, [
      [2, 1.5],
      [2.5, 2],
      [3, 2.5],
      [3.5, 3],
      [4, 3],
      [5, 4],
      [6, 5],
      [7, 5],
      [8, 6],
      [10, 8],
      [12, 10],
      [14, 12],
      [16, 14],
      [18, 15],
      [20, 17],
      [22, 18],
      [24, 19],
      [27, 20],
      [30, 22],
      [33, 24],
      [36, 27],
      [39, 30],
      [42, 32],
      [48, 36],
      [52, 36],
      [56, 41],
      [60, 42],
      [64, 46]
        ]) : return;
  
 

////////////////////////////////////////////////////////////////////////////
//function to return across points dimention for metric Allen head sockets
// Provides standard metric hex Allen head diameters across points from across flats size.


function AllenAcrosFlatsToPointsDia(diameter) =
  ThreadToAllenHeadAcrossFlats(diameter) / cos(30);
  
  
////////////////////////////////////////////////////////////////////////////
//function to return standard metric nut thickness from thread size

function NutThickness(height) =
  (height <= 64) ?
    lookup(height, [
      [2, 1.6],
      [2.5, 2],
      [3, 2.4],
      [3.5, 2.8],
      [4, 3.2],
      [5, 4.7],
      [6, 5.2],
      [7, 6.0],
      [8, 6.8],
      [10, 8.4],
      [12, 10.8],
      [14, 12.8],
      [16, 14.8],
      [18, 15.8],
      [20, 18.0],
      [22, 21.1],
      [24, 21.5],
      [27, 23.8],
      [30, 25.6],
      [33, 28.7],
      [36, 31.0],
      [42, 34],
      [48, 38],
      [56, 45],
      [64, 51]
        ]) : return;
  
 ////////////////////////////////////////////////////////////////////////////
//function to return clearance hole size for a metric thread

 
function ThreadToClearanceHole(size) =
  (size <= 64) ?
    lookup(size, [
      [2, 2.05],
      [2.5, 2.6],
      [3, 3.1],
      [3.5, 3.6],
      [4, 4.1],
      [5, 5.1],
      [6, 6.1],
      [7, 7.2],
      [8, 8.2],
      [10, 10.2],
      [12, 12.2],
      [14, 14.25],
      [16, 16.25],
      [18, 18.25],
      [20, 20.25],
      [22, 22.25],
      [24, 24.25],
      [27, 27.25],
      [30, 30.5],
      [33, 33.5],
      [36, 36.5],
      [39, 39.5],
      [42, 42.5],
      [45, 45.5],
      [48, 48.75],
      [52, 52.75],
      [56, 56.75],
      [60, 60.75],
      [64, 64.75]
        ]) : return;
        
        
////////////////////////////////////////////////////////////////////////////
//function to return cap screw head diameter clearance hole size

 
function ThreadToCapHeadDiameter(size) =
  (size <= 64) ?
    lookup(size, [
      [2, 3.5],
      [2.5, 2.6],
      [3, 5.5],
      [3.5, 3.6],
      [4, 7.0],
      [5, 8.5],
      [6, 10.0],
      [7, 11.5],
      [8, 13.0],
      [10, 16.0],
      [12, 18.0],
      [14, 21.0],
      [16, 24.0],
      [18, 27.0],
      [20, 30.0],
      [22, 33.0],
      [24, 36.0],
      [27, 40.0],
      [30, 45.0],
      [33, 33.5],
      [36, 36.5],
      [39, 39.5],
      [42, 42.5],
      [45, 45.5],
      [48, 48.75],
      [52, 52.75],
      [56, 56.75],
      [60, 60.75],
      [64, 60.75]
        ]) : return;
  
 ////////////////////////////////////////////////////////////////////////////
//function to return cap screw head diameter clearance hole size

 
function ThreadToCapHeadDepth(size) =
  (size <= 64) ?
    lookup(size, [
      [2, 2.0],
      [2.5, 2.5],
      [3, 3.0],
      [3.5, 3.5],
      [4, 4.0],
      [5, 5.0],
      [6, 6.0],
      [7, 7.0],
      [8, 8.0],
      [10, 10.0],
      [12, 12.0],
      [14, 14.0],
      [16, 16.0],
      [18, 18.0],
      [20, 20.0],
      [22, 22.0],
      [24, 24.0],
      [27, 27.0],
      [30, 30.0],
      [33, 33.0],
      [36, 36.0],
      [39, 39.0],
      [42, 42.0],
      [45, 45.0],
      [48, 48.0],
      [52, 52.0],
      [56, 56.0],
      [60, 60.0],
      [64, 60.0]
        ]) : return;
  
 
////////////////////////////////////////////////////////////////////////////
//END MODULE SECTION 
////////////////////////////////////////////////////////////////////////////
